//+------------------------------------------------------------------+
//|                                              
//|                     
//|                                     
//+------------------------------------------------------------------+
//#define MAGICMA  1960//20050610
extern double MAGICMA = 1960;
extern string  = " :"; //  100  = /1000 ,   10      ,     .
extern double Lots               = 1;
extern double MaximumRisk        = 100;
extern double  = 500;
extern double DEP = 0;
extern double DecreaseFactor     = 2;
extern double TakeProfit =20;
extern double StopLoss = 150;
extern double taimtrend = 5;
extern string  = "PMA- K D P  :";
extern int    K = 15;
extern int    D = 3;
extern int    P = 3;
extern int    J = 3;
extern double PMA = 11;
extern string  = "    :";
extern double TrailingStop =3;
extern double UB = 20; 
extern double US = 80;
extern double BUI =1;
extern double SELL = 1;
extern double CloseB = 0;
extern double CloseS = 0;
extern double PRICE =0;
extern double PRICETREND = 1;
extern double CODA =0; //    
extern int start=1;






//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
  {
   int buys=0,sells=0;
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA)
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
//---- return orders volume
   if(buys>0) return(buys);
   else       return(-sells);
  }
//+------------------------------------------------------------------+
//| Calculate optimal lot size                                       |
//+------------------------------------------------------------------+
double LotsOptimized()
  {
   double lot=Lots;
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
//---- select lot size
   lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/1000.0,1);
//---- calcuulate number of losses orders without a break
   if(DecreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1) lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,1);
     }
//---- return lot size
   if(MaximumRisk==0) lot=Lots;
   if(lot<0.01) lot=0.01;
   if(MaximumRisk==10) lot = * DEP * AccountFreeMargin() / 150000;
   if(MaximumRisk==100) lot =  AccountFreeMargin() / 1000;
   if(lot>100) lot=100;
   return(lot);
  }
// MODIFI


//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+


int (int x)
{
  
   static int trend1;
   double X;
   if(PRICE ==1)X=MODE_MAIN;
   if(PRICE ==0)X=MODE_SIGNAL;
   double O = iOpen(NULL, 1, 0);
   double C = iClose(NULL, 1, 0);
   double C1 = iClose(NULL, 1, 1);
   double L = iLow(NULL, 1, 0);
   double H = iHigh(NULL, 1, 0);
   
   double MA = iMA(NULL,1,PMA,0, MODE_SMA,PRICE_CLOSE, 0);
   
   double S = iCustom(NULL,5,"ST",K,D,P,J,100,PRICETREND, 0);
   double S1 = iCustom(NULL,5,"ST",K,D,P,J,100,PRICETREND, 1);
   
   double S2 = iCustom(NULL,1,"ST",K,D,P,J,100,PRICE, 2);
   double S3 = iCustom(NULL,1,"ST",K,D,P,J,100,PRICE, 3);
   double SI = iCustom(NULL,1,"ST",K,D,P,J,100,PRICE, 0);
   double SI1 = iCustom(NULL,1,"ST",K,D,P,J,100,PRICE, 1);
   double SI2 = iCustom(NULL,1,"ST",K,D,P,J,100,PRICE, 2);
   
   double SI5 = iCustom(NULL,taimtrend,"ST",K,D,P,J,100,PRICETREND, 0);
   double SI51 = iCustom(NULL,taimtrend,"ST",K,D,P,J,100,PRICETREND, 1);
   
  /* double S = iStochastic(NULL,5,K,D,P, MODE_SMA, 0, MODE_SIGNAL,0);  
   double S1 = iStochastic(NULL,5,K,D,P, MODE_SMA, 0,MODE_SIGNAL,1);
   double S2 = iStochastic(NULL,1,K,D,P, MODE_SMA, 0,X,2);
   double S3 = iStochastic(NULL,1,K,D,P, MODE_SMA, 0,X,3);
   double SI = iStochastic(NULL,1,K,D,P, MODE_SMA, 0,X,0);
   double SI1 = iStochastic(NULL,1,K,D,P, MODE_SMA, 0,X,1);
   double SI2 = iStochastic(NULL,1,K,D,P, MODE_SMA, 0,X,2); 
   
   double SI5 = iStochastic(NULL,taimtrend,K,D,P, MODE_SMA, 0, MODE_SIGNAL,0);
   double SI51 = iStochastic(NULL,taimtrend,K,D,P, MODE_SMA, 0, MODE_SIGNAL,1);
   */
   double M = iMA(NULL,1,1,0, MODE_SMA,PRICE_MEDIAN, 0);
   double M1 = iMA(NULL,1,1,0, MODE_SMA,PRICE_MEDIAN, 1);
   
   int trend = trend1;
   
        if (Ask>H&&C<MA&&SI1<UB&&SI5>SI51&&S>S1&&M>M1) trend =1;
        if (Bid<=L&&C<O&&C>MA&&SI1>US&&SI5<SI51&&S<S1&&M<M1) trend =-1;
        
        if(OrderType()==OP_SELL&&trend ==1&&CloseS==1) { OrderClose(OrderTicket(),OrderLots(),Ask,3,White);}
        if(OrderType()==OP_BUY&&trend ==-1&&CloseB==1){ OrderClose(OrderTicket(),OrderLots(),Bid,3,White);}
        
         if(iBarShift(NULL, 1440, OrderOpenTime()) > 0 && CODA == 1)
   {
    OrderClose(OrderTicket(),OrderLots(),Bid,3,White);
    OrderClose(OrderTicket(),OrderLots(),Ask,3,White);
   }
        return (trend);

}


void CheckForOpen()
  {
   double ma,SL,TP,ticket;
   int    res;

  // if(Volume[0]>1) return;



     
  int trend= (start);

//---- sell conditions
 
   if(trend==-1&&SELL==1)  
     {
      RefreshRates();
         SL = Ask + StopLoss * Point;
         TP = Ask - TakeProfit * Point;
      res=OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,3,SL,TP,"",MAGICMA,0,Red);
      return;
     }
//---- buy conditions
 
   if(trend==1&&BUI==1)
     {
     RefreshRates();
         SL = Bid - StopLoss * Point;
         TP = Bid+TakeProfit*Point;
      res=OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,3,SL,TP,"",MAGICMA,0,Blue);
      return;
     }
//----
  }
// MODIFI
 

 

//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()
  {
   double TS = TrailingStop;
   double R = Ask -Bid ;
//---- go trading only for first tiks of new bar
  
   if(TrailingStop < R) TS = R*Point ;

   int trend=(start);
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderMagicNumber()!=MAGICMA || OrderSymbol()!=Symbol()) continue;
      //---- check order type 
      if(OrderType()==OP_BUY&&TS > 0&&(Bid - OrderOpenPrice()) >= TS* Point&&OrderStopLoss() < (Bid - Point * TS))
        {
         OrderModify(OrderTicket(), OrderOpenPrice(), Bid - Point * TS,
                        OrderClosePrice() + OrderTakeProfit() * Point + TS * Point, 0, CLR_NONE);
         break;
        }
       
      if(OrderType()==OP_SELL&&TS > 0&&(OrderOpenPrice() - Ask) >= TS* Point&&OrderStopLoss() > (Ask + Point * TS))
        {
        OrderModify(OrderTicket(), OrderOpenPrice(), Ask + Point * TS, 
                        OrderClosePrice() - OrderTakeProfit() * Point - TS * Point, 0, CLR_NONE);        
         break;
        }
     }
//----
  }
//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()
  {
//---- check for history and trading
   if(start!=0) 
  
   if(Bars<100 || IsTradeAllowed()==false) return;
//---- calculate open orders by current symbol
   if(CalculateCurrentOrders(Symbol())==0) CheckForOpen();
   else                                    CheckForClose();
//----
  }
//+------------------------------------------------------------------+